package com.slugwars;

import com.badlogic.gdx.Game;
import com.badlogic.gdx.Gdx;
import com.badlogic.gdx.graphics.GL20;
import com.badlogic.gdx.graphics.g2d.BitmapFont;
import com.badlogic.gdx.graphics.g2d.GlyphLayout;
import com.badlogic.gdx.scenes.scene2d.InputEvent;
import com.badlogic.gdx.scenes.scene2d.InputListener;
import com.badlogic.gdx.scenes.scene2d.Stage;
import com.badlogic.gdx.scenes.scene2d.ui.Skin;
import com.badlogic.gdx.scenes.scene2d.ui.TextButton;

public class FinishScreen extends BaseScreen {

    private Player winner;
    private Stage stage;
    private Skin skin;
    private String str;
    private BitmapFont font;
    private GlyphLayout layout;

    public FinishScreen(MainGame game, Player winner) {
        super(game);
        skin = new Skin(Gdx.files.internal("glassy-ui.json"));
        this.winner = winner;
    }
    @Override
    public void show() {
        stage = new Stage();
        font = new BitmapFont();
        font.getData().setScale(3f,3f);

        str = "Ganador:\n\n" +
                winner.getName() +"\n\nCon puntuación:\n\n" +
                Integer.toString(winner.getScore());

        layout = new GlyphLayout();
        layout.setText(font, str);


        Gdx.input.setInputProcessor(stage);

        TextButton back = new TextButton("Atras", skin);
        back.setBounds(0,0, 200,100);
        back.addListener(new InputListener(){
            @Override
            public boolean touchDown(InputEvent event, float x, float y, int pointer, int button) {
                ((Game)Gdx.app.getApplicationListener()).setScreen(new MenuScreen(game));
                return true;
            }
        });

        stage.addActor(back);

    }
    @Override
    public void render(float delta) {
        Gdx.gl.glClearColor(0.0f,0.0f, 0.5f, 1f);
        Gdx.gl.glClear(GL20.GL_COLOR_BUFFER_BIT);

        game.batch.begin();
        font.draw(game.batch, str, Gdx.graphics.getWidth()/2 - layout.width/2
                , Gdx.graphics.getHeight() - layout.height/2);
        game.batch.end();
        
        game.batch.begin();
        stage.act();
        stage.draw();
        game.batch.end();
    }

    @Override
    public void hide() {
        stage.dispose();
    }

    @Override
    public void dispose() {
        skin.dispose();
        font.dispose();
    }
}
