package com.slugwars;

import com.badlogic.gdx.Gdx;
import com.badlogic.gdx.InputMultiplexer;
import com.badlogic.gdx.graphics.GL20;
import com.badlogic.gdx.graphics.OrthographicCamera;
import com.badlogic.gdx.scenes.scene2d.Stage;

public class GameScreen extends BaseScreen
{
    private Stage mapstage;
    private OrthographicCamera camera;
    private OrthoCamController cameraController;

    public GameScreen(MainGame game)
    {
        super(game);
    }

    @Override
    public void render(float delta) {
        Gdx.gl.glClearColor(0.25f, 0.25f, 0.25f, 1f);
        Gdx.gl.glClear(GL20.GL_COLOR_BUFFER_BIT);
        mapstage.act();
        mapstage.draw();
        camera.update();
    }

    @Override
    public void show() {
        mapstage = new Stage();
        camera = (OrthographicCamera)mapstage.getCamera();
        cameraController = new OrthoCamController(camera);
        camera.zoom += 0.5f;
        camera.translate(500,500);
        camera.update();
        //mapstage.setDebugAll(true);
        for(HexActor actor : game.actors)
        {
            mapstage.addActor(actor);
        }
        InputMultiplexer inputMultiplexer = new InputMultiplexer();
        inputMultiplexer.addProcessor(mapstage);
        inputMultiplexer.addProcessor(cameraController);
        Gdx.input.setInputProcessor(inputMultiplexer);
    }

    @Override
    public void hide()
    {
        mapstage.dispose();
    }

}
