package com.slugwars;

import com.badlogic.gdx.graphics.Texture;
import com.badlogic.gdx.graphics.g2d.Batch;
import com.badlogic.gdx.scenes.scene2d.Actor;

public class HexActor extends Actor {

    private int hexX,hexY;
    private int pX, pY;
    private Texture actorTexture;
    private int player = 0; //0 no es de nadie, 1 es de player 1, 2 es de player 2, 3 se esta moviendo desde player1, 4 se esta moviendo desde player2
    private boolean select = false;

    public HexActor(int hexX, int hexY, int pX, int pY, Texture actorTexture) {
        this.hexX = hexX;
        this.hexY = hexY;
        this.pX = pX;
        this.pY = pY;
        this.actorTexture = actorTexture;
        setPosition(pX+70,pY+10);
        setSize(120, 190);
    }

    public int getHexX()
    {
        return hexX;
    }

    public int getHexY()
    {
        return hexY;
    }


    public boolean isSelect()
    {
        return select;
    }

    public void onSelect(){
        select = true;
    }

    public void offSelect(){
        select = false;
    }

    public void around(int aroundMe[])
    {
        int upperI = 11*(hexX+1);
        int lowerI = 11*(hexX);
        aroundMe[0] = 11*hexX + (hexY+1);
        aroundMe[0] = (aroundMe[0] >= lowerI && aroundMe[0] < upperI) ? aroundMe[0] : -1;
        aroundMe[1] = 11*hexX + (hexY-1);
        aroundMe[1] = (aroundMe[1] >= lowerI && aroundMe[1] < upperI) ? aroundMe[1] : -1;
        if(hexX % 2 == 0){
            upperI = 11*(hexX + 2);
            lowerI = 11*(hexX + 1);
            aroundMe[2] = 11*(hexX+1) + (hexY);
            aroundMe[2] = (aroundMe[2] >= lowerI && aroundMe[2] < upperI) ? aroundMe[2] : -1;
            aroundMe[4] = 11*(hexX+1) + (hexY-1);
            aroundMe[4] = (aroundMe[4] >= lowerI && aroundMe[4] < upperI) ? aroundMe[4] : -1;
            upperI = 11*(hexX - 0);
            lowerI = 11*(hexX - 1);
            aroundMe[3] = 11*(hexX-1) + (hexY);
            aroundMe[3] = (aroundMe[3] >= lowerI && aroundMe[3] < upperI) ? aroundMe[3] : -1;
            aroundMe[5] = 11*(hexX-1) + (hexY-1);
            aroundMe[5] = (aroundMe[5] >= lowerI && aroundMe[5] < upperI) ? aroundMe[5] : -1;
        }
        else {
            upperI = 11*(hexX + 2);
            lowerI = 11*(hexX + 1);
            aroundMe[2] = 11*(hexX+1) + (hexY+1);
            aroundMe[2] = (aroundMe[2] >= lowerI && aroundMe[2] < upperI) ? aroundMe[2] : -1;
            aroundMe[4] = 11*(hexX+1) + (hexY);
            aroundMe[4] = (aroundMe[4] >= lowerI && aroundMe[4] < upperI) ? aroundMe[4] : -1;
            upperI = 11*(hexX - 0);
            lowerI = 11*(hexX - 1);
            aroundMe[3] = 11*(hexX-1) + (hexY+1);
            aroundMe[3] = (aroundMe[3] >= lowerI && aroundMe[3] < upperI) ? aroundMe[3] : -1;
            aroundMe[5] = 11*(hexX-1) + (hexY);
            aroundMe[5] = (aroundMe[5] >= lowerI && aroundMe[5] < upperI) ? aroundMe[5] : -1;
        }
    }

    public void setTexture(Texture newTexture)
    {
        actorTexture = newTexture;
    }

    public void setPlayer(int player)
    {
        this.player = player;
    }

    public int getPlayer()
    {
        return player;
    }

    @Override
    public void draw(Batch batch, float parentAlpha) {
        batch.draw(actorTexture, pX, pY);
    }
}