package com.slugwars;

import com.badlogic.gdx.graphics.Texture;
import com.badlogic.gdx.scenes.scene2d.InputEvent;
import com.badlogic.gdx.scenes.scene2d.InputListener;

import sun.applet.Main;

public class HexInputListener extends InputListener
{
    private HexActor actor;
    private Texture hexture0, hexture1, hexture2, slugture1, slugture2;
    private MainGame game;
    private int[] around, aroundSelect;

    public HexInputListener(MainGame game, HexActor actor, Texture hexture0, Texture hexture1, Texture hexture2, Texture slugture1, Texture slugture2)
    {
        this.actor = actor;
        this.hexture0 = hexture0;
        this.hexture1 = hexture1;
        this.hexture2 = hexture2;
        this.slugture1 = slugture1;
        this.slugture2 = slugture2;
        this.game = game;
        actor.addListener(this);
        around = new int[6];
        aroundSelect = new int[6];
        actor.around(around);
    }

    @Override
    public boolean touchDown(InputEvent event, float x, float y, int pointer, int button) {
        if(actor.getPlayer() == 0){
            if(actor.isSelect()){
                if(!game.turn){
                    actor.setTexture(slugture1);
                    actor.setPlayer(1);
                    game.p1.incScore(1);
                    for(int i : around){
                        if(i >= 0 && i < 121 && game.actors[i].getPlayer()==2){
                            game.actors[i].setPlayer(1);
                            game.actors[i].setTexture(slugture1);
                            game.p1.incScore(1);
                            game.p2.decScore(1);
                        }
                    }
                }
                else{
                    actor.setTexture(slugture2);
                    actor.setPlayer(2);
                    game.p2.incScore(1);
                    for(int i : around){
                        if(i >= 0 && i < 121 && game.actors[i].getPlayer()==1){
                            game.actors[i].setPlayer(2);
                            game.actors[i].setTexture(slugture2);
                            game.p2.incScore(1);
                            game.p1.decScore(1);
                        }
                    }
                }
                actor.offSelect();
                game.actorSelect = null;
                game.nextTurn();
            }
            else{
                if(!game.turn){
                    if(game.actorSelect != null) {
                        game.actorSelect.setTexture(hexture0);
                        game.actorSelect.offSelect();
                    }
                    actor.setTexture(hexture1);
                }
                else{
                    if(game.actorSelect != null) {
                        game.actorSelect.setTexture(hexture0);
                        game.actorSelect.offSelect();
                    }
                    actor.setTexture(hexture2);
                }
                actor.onSelect();
                game.actorSelect = actor;
            }
        }
        else if((actor.getPlayer() == 1 && !game.turn) || (actor.getPlayer() == 2 && game.turn)){
            if(actor.isSelect()){
                for(int i : around){
                    if(i >= 0 && i < 121 && game.actors[i].getPlayer()!= 1 && game.actors[i].getPlayer()!= 2) {
                        game.actors[i].setTexture(hexture0);
                        game.actors[i].setPlayer(0);
                    }
                }
                actor.offSelect();
                game.actorSelect = null;
            }
            else{
                if(game.actorSelect == null) {
                    for (int i : around) {
                        if (i >= 0 && i < 121 && game.actors[i].getPlayer() == 0) {
                            if (!game.turn) {
                                game.actors[i].setTexture(hexture1);
                                game.actors[i].setPlayer(3);
                            } else {
                                game.actors[i].setTexture(hexture2);
                                game.actors[i].setPlayer(4);
                            }
                        }
                    }
                }
                else{
                    game.actorSelect.offSelect();
                    game.actorSelect.around(aroundSelect);
                    for(int i : aroundSelect){
                        if(i >= 0 && i < 121 && game.actors[i].getPlayer()!= 1 && game.actors[i].getPlayer()!= 2) {
                            game.actors[i].setTexture(hexture0);
                            game.actors[i].setPlayer(0);
                        }
                    }
                    for (int i : around) {
                        if (i >= 0 && i < 121 && game.actors[i].getPlayer() == 0) {
                            if (!game.turn) {
                                game.actors[i].setTexture(hexture1);
                                game.actors[i].setPlayer(3);
                            } else {
                                game.actors[i].setTexture(hexture2);
                                game.actors[i].setPlayer(4);
                            }
                        }
                    }
                }
                actor.onSelect();
                game.actorSelect = actor;
            }
        }
        else if(actor.getPlayer() == 3){
            actor.setTexture(slugture1);
            actor.setPlayer(1);
            game.actorSelect.setTexture(hexture0);
            game.actorSelect.setPlayer(0);
            game.actorSelect.offSelect();
            game.actorSelect.around(aroundSelect);
            for(int i : aroundSelect){
                if(i >= 0 && i < 121 && game.actors[i].getPlayer()== 3) {
                    game.actors[i].setTexture(hexture0);
                    game.actors[i].setPlayer(0);
                }
            }
            for(int i : around){
                if(i >= 0 && i < 121 && game.actors[i].getPlayer()==2){
                    game.actors[i].setPlayer(1);
                    game.actors[i].setTexture(slugture1);
                    game.p1.incScore(1);
                    game.p2.decScore(1);
                }
            }
            game.nextTurn();
        }
        else if(actor.getPlayer() == 4){
            actor.setTexture(slugture2);
            actor.setPlayer(2);
            game.actorSelect.setTexture(hexture0);
            game.actorSelect.setPlayer(0);
            game.actorSelect.offSelect();
            game.actorSelect.around(aroundSelect);
            for(int i : aroundSelect){
                if(i >= 0 && i < 121 && game.actors[i].getPlayer()== 4) {
                    game.actors[i].setTexture(hexture0);
                    game.actors[i].setPlayer(0);
                }
            }
            for(int i : around){
                if(i >= 0 && i < 121 && game.actors[i].getPlayer()==1){
                    game.actors[i].setPlayer(2);
                    game.actors[i].setTexture(slugture2);
                    game.p2.incScore(1);
                    game.p1.decScore(1);
                }
            }
            game.nextTurn();
        }
        if(game.p1.getScore() + game.p2.getScore() == 121){
            if(game.p1.getScore() > game.p2.getScore()) game.setScreen(new FinishScreen(game, game.p1));
            else game.setScreen(new FinishScreen(game, game.p2));
        }
        return false;
    }
}