package com.slugwars;

import com.badlogic.gdx.Game;
import com.badlogic.gdx.Gdx;
import com.badlogic.gdx.graphics.GL20;
import com.badlogic.gdx.graphics.g2d.BitmapFont;
import com.badlogic.gdx.scenes.scene2d.InputEvent;
import com.badlogic.gdx.scenes.scene2d.InputListener;
import com.badlogic.gdx.scenes.scene2d.Stage;
import com.badlogic.gdx.scenes.scene2d.ui.Skin;
import com.badlogic.gdx.scenes.scene2d.ui.TextButton;

public class InstructionScreen extends BaseScreen
{
    private Stage stage;
    private Skin skin;
    private BitmapFont font;
    private static final CharSequence str =
            "Cada turno el jugador puede mover en una\n" +
            "posición alguna de sus babosas o crear una\n" +
            "babosa en alguna casilla. En el caso de que\n" +
            "haya alguna babosa enemiga en las posiciones\n" +
            "adyacentes, el jugador de turno conquistará\n" +
            "todas ellas.\n\n" +
            "El juego termina cuando no queden casillas sin\n" +
            "conquistar y el jugador con más babosas\n" +
            "en ese momento será el ganador.";

    public InstructionScreen(MainGame game)
    {
        super(game);
        skin = new Skin(Gdx.files.internal("glassy-ui.json"));
    }

    @Override
    public void show() {
        stage = new Stage();
        font = new BitmapFont();
        font.getData().setScale(3f,3f);


        Gdx.input.setInputProcessor(stage);

        TextButton back = new TextButton("Atras", skin);
        back.setBounds(0,0, 200,100);
        back.addListener(new InputListener(){
            @Override
            public boolean touchDown(InputEvent event, float x, float y, int pointer, int button) {
                ((Game)Gdx.app.getApplicationListener()).setScreen(new MenuScreen(game));
                return true;
            }
        });

        stage.addActor(back);

    }

    @Override
    public void render(float delta) {
        Gdx.gl.glClearColor(0.0f,0.0f, 0.5f, 1f);
        Gdx.gl.glClear(GL20.GL_COLOR_BUFFER_BIT);

        game.batch.begin();
        font.draw(game.batch, str, 0, Gdx.graphics.getHeight());
        game.batch.end();

        game.batch.begin();
        stage.act();
        stage.draw();
        game.batch.end();
    }

    @Override
    public void hide() {
        stage.dispose();
    }

    @Override
    public void dispose() {
        skin.dispose();
        font.dispose();
    }



}