package com.slugwars;

import com.badlogic.gdx.Game;
import com.badlogic.gdx.Gdx;
import com.badlogic.gdx.graphics.Texture;
import com.badlogic.gdx.graphics.g2d.SpriteBatch;
import com.badlogic.gdx.scenes.scene2d.EventListener;

public class MainGame extends Game
{
	protected SpriteBatch batch;
	protected Player p1;
	protected Player p2;
	protected Texture hexture0, hexture1, hexture2, slugture1, slugture2;
	protected HexActor[] actors;
	protected boolean turn = false;
	protected HexActor actorSelect;

	@Override
	public void create () {
		p1 = new Player();
		p2 = new Player();
		batch = new SpriteBatch();
		actors = new HexActor[121];

		float w = Gdx.graphics.getWidth();
		float h = Gdx.graphics.getHeight();

		hexture0 = new Texture("hex0.png");
		hexture1 = new Texture("hex1.png");
		hexture2 = new Texture("hex2.png");
		slugture1 = new Texture("slug1.png");
		slugture2 = new Texture("slug2.png");

		int pX, pY;

		for(int x = 0; x < 11; x++){
			pX = x*192 + 5;
			if(x % 2 == 0){
				pY = 0;
			}
			else{
				pY = hexture0.getWidth()/2 - 20;
			}
			for(int y = 0; y < 11; y++) {
				actors[11*x+y] = new HexActor(x, y, pX, pY + y * hexture0.getHeight(), hexture0);
				EventListener eventListener = new HexInputListener(this, actors[11*x+y], hexture0, hexture1, hexture2, slugture1, slugture2);
			}
		}

		setScreen(new MenuScreen(this));
	}


	@Override
	public void dispose () {
		hexture0.dispose();
		hexture1.dispose();
		hexture2.dispose();
		slugture1.dispose();
		slugture2.dispose();
	}

	public void nextTurn(){
		turn = !turn;
	}
}


