package com.slugwars;

import com.badlogic.gdx.Game;
import com.badlogic.gdx.Gdx;
import com.badlogic.gdx.InputMultiplexer;
import com.badlogic.gdx.graphics.GL20;
import com.badlogic.gdx.scenes.scene2d.InputEvent;
import com.badlogic.gdx.scenes.scene2d.InputListener;
import com.badlogic.gdx.scenes.scene2d.Stage;
import com.badlogic.gdx.scenes.scene2d.ui.Skin;
import com.badlogic.gdx.scenes.scene2d.ui.TextButton;
import com.badlogic.gdx.scenes.scene2d.ui.TextField;

public class PlayerScreen extends BaseScreen
{
    private Stage stage;
    private Skin skin;

    public PlayerScreen(MainGame game) {
        super(game);
        skin = new Skin(Gdx.files.internal("glassy-ui.json"));
    }

    @Override
    public void show() {
        stage = new Stage();

        MyTextListener listener = new MyTextListener(game);
        Gdx.input.getTextInput(listener, "Player2", "", "Hint Value");
        Gdx.input.getTextInput(listener, "Player1", "", "Hint Value");

        Gdx.input.setInputProcessor(stage);
        ((Game)Gdx.app.getApplicationListener()).setScreen(new GameScreen(game));
    }

    @Override
    public void render(float delta) {
        Gdx.gl.glClearColor(0.1f,0.1f, 1f, 1f);
        Gdx.gl.glClear(GL20.GL_COLOR_BUFFER_BIT);

        stage.act();
        game.batch.begin();
        stage.draw();
        game.batch.end();
    }

    @Override
    public void dispose() {
        skin.dispose();
    }

    @Override
    public void hide() {
        stage.dispose();
    }
}